let commonExtend = {
	initPickerForQuery: function(el, self, listName, value, func) {
		return this.initPicker(el, self, listName, value, func, true, false);
	},
	initPickerForNonQuery: function(el, self, listName, value, func) {
		return this.initPicker(el, self, listName, value, func, false, true);
	},
	initPicker: function(el, self, listName, value, func, usedForQuery, usedForNonQuery) {
		var array = listExtendUtil.getNames(listName, usedForQuery, usedForNonQuery);
		var srcName = listExtendUtil.getNameByValue(value, listName);
		console.log("原始名称" + srcName);
		var cancelEl = el + "-cancel";
		var sureEl = el + "-sure";
		var selectName;
		var p = app.picker.create({
			inputEl: '#' + el,
			rotateEffect: true,
			backdrop: true,
			value: srcName ? [srcName] : null,
			renderToolbar: function() {
				return '<div class="toolbar">' +
					'<div class="toolbar-inner">' +
					'<div class="left">' +
					'<a href="#" class="link sheet-close popover-close ' + cancelEl + '">取消</a>' +
					'</div>' +
					'<div class="right">' +
					'<a href="#" class="link sheet-close popover-close ' + sureEl + '">确定</a>' +
					'</div>' +
					'</div>' +
					'</div>';
			},
			cols: [{
				values: array,
				onChange: function(picker, name) {
					selectName = name;
					console.log(name);
				},
				textAlign: 'center',
			}, ],
			on: {
				open: function(picker) {
					picker.$el.find('.' + cancelEl).on('click', function() {
						picker.setValue([srcName]);
						console.log('取消');
					});
					picker.$el.find('.' + sureEl).on('click', function() {
						srcName = selectName;
						func(selectName);
						console.log('确定');
					});
				},
				closed: function(picker) {
					picker.setValue([srcName]);
					console.log('关闭');
				}
			}
		});
		console.log(p);
		return p;
	},
	setPicker: function(picker, listName, value) {
		if (value == null) {
			return;
		}
		var name = listExtendUtil.getNameByValue(value, listName);
		picker.setValue([name]);
	},
	initDatePicker: function(el, self, defaultValue, func) {
		console.log("日期的值：" + defaultValue);
		var cancelEl = el + "-cancel";
		var sureEl = el + "-sure";
		var calendarDefault = app.calendar.create({
			inputEl: '#' + el,
			dateFormat: {
				year: 'numeric',
				month: '2-digit',
				day: '2-digit'
			},
		});
		calendarDefault.on("calendarChange", function(calendar, value) {
			self.$setState({
				birthday: common.timereversal(new Date(value)),
			});
			if (func != null) {
				func(self.birthday);
			}
		});
		if (defaultValue != null) {
			var array = defaultValue.split('-');
			calendarDefault.setValue([new Date(parseInt(array[0]), parseInt(array[1]) - 1,
				parseInt(array[2]))]);
		}
		return calendarDefault;
	},
	setDatePicker: function(picker, value) {
		if (value == null) {
			return;
		}
		console.log("日期的值" + value);
		var array = value.split('-');
		picker.setValue([new Date(parseInt(array[0]), parseInt(array[1]) - 1,
			parseInt(array[2]))]);
	},
	initAddressPicker: function(el, self, defaultValue, func) {
		var self = this;
		var cancelEl = el + "-cancel";
		var sureEl = el + "-sure";
		if (!emptyUtil.isNotEmptyRegion(defaultValue)) {
			defaultValue[0] = '北京市';
			defaultValue[1] = '北京市';
		}

		app.request({
			url: global.addressUrl,
			data: Encrypt({
				isNotNeedAddAll: true
			}),
			headers: authheaders,
			method: 'POST',
			dataType: 'json',
			success: function(r, status, xhr) {
				r = DecryptToJson(r);
				console.log(r);
				var addressData = r.data;
				var map = new Map();
				var provinceList = addressData.provinceList;
				// console.log(provinceList);
				var selectRegionSrc = ['全部'];
				var selectRegion;
				//每个省份对应的城市集合
				let provinceCityMap = new Map();
				for (let item in addressData.provinceCityMap) {
					provinceCityMap.set(item, addressData.provinceCityMap[item])
				}
				//每个城市对应的区集合
				let cityAreaMap = new Map();
				for (let item in addressData.cityAreaMap) {
					cityAreaMap.set(item, addressData.cityAreaMap[item])
				}
				app.picker.create({
					inputEl: '#' + el,
					rotateEffect: true,
					backdrop: true,
					value: defaultValue,
					renderToolbar: function() {
						return '<div class="toolbar">' +
							'<div class="toolbar-inner">' +
							'<div class="left">' +
							'<a href="#" class="link sheet-close popover-close ' +
							cancelEl + '">取消</a>' +
							'</div>' +
							'<div class="right">' +
							'<a href="#" class="link sheet-close popover-close ' +
							sureEl + '">确定</a>' +
							'</div>' +
							'</div>' +
							'</div>';
					},
					formatValue: function(values) {
						selectRegion = values;
						return values[0] + ',' + values[1];
					},
					cols: [{
							textAlign: 'left',
							values: provinceList,
							onChange: function(picker, name) {
								if (picker.cols[1].replaceValues) {
									picker.cols[1].replaceValues(provinceCityMap
										.get(name));
								}
							},
							width: 160,
						},
						{
							values: provinceCityMap.get(provinceList[0]),
							width: 160,
						},
					],
					on: {
						open: function(picker) {
							picker.$el.find('.' + cancelEl).on('click', function() {
								picker.setValue(defaultValue);
								console.log('取消');
							});
							picker.$el.find('.' + sureEl).on('click', function() {
								defaultValue = selectRegion;
								func(selectRegion);
								console.log('确定');
							});
						},
						closed: function(picker) {
							picker.setValue(defaultValue);
							console.log('关闭');
						}
					}
				});
			}
		});
	},
	inspectionItems: function(queryParam, successFunction) {
		var object = new Object();
		object.inspectionItemsEnums = queryParam;
		console.log("inspectionItems请求入参" + JSON.stringify(object));
		app.request({
			url: global.inspectionItems,
			data: Encrypt(object),
			headers: authheaders,
			method: 'POST',
			dataType: 'json',
			success: function(r, status, xhr) {
				var res = DecryptToJson(r);
				console.log("inspectionItems返回结果" + JSON.stringify(res));
				if (res.code != 1) {
					if (res.code == 10002) {
						app.dialog.confirm('请您先完善好个人资料(生日、手机号、身份、性别)后再来发布约拍信息喔', function() {
							app.views.current.router.navigate({
								path: '/personinfo/',
							});
						});
					} else if (res.code == 100) {
						app.dialog.confirm('积分余额不足，是否前往充值', function() {
							app.views.current.router.navigate({
								path: '/jifenhome/',
							});
						});
					} else {
						common.toast(res.message);
					}
				} else {
					successFunction();
				}
			},
			error: function(xhr, status, message) {
				common.toast("网络异常，请稍后重试");
			}
		});
	},
	inviteScore: function() {

		if (systemPlaform != 'ios') {
			return;
		}

		if (this.getStorage('isAlreadyScoreApp') && this.getStorage('isAlreadyScoreApp') == '1') {
			var signDialog = app.dialog.create({
				title: '给我们评分',
				text: '喜欢我，就给我个好评吧，我会继续努力做得更好!',
				verticalButtons: true,
				buttons: [{
						text: '不了，谢谢',
						onClick: function(dialog, e) {
							this.setStorage('isAlreadyScoreApp', '1', 1000 * 60 * 24 * 90);
						}
					},
					{
						text: '我要吐槽',
						onClick: function(dialog, e) {
							this.setStorage('isAlreadyScoreApp', '1', 1000 * 60 * 24 * 90);
							app.views.current.router.navigate({
								path: '/system-feedback/',
							});
						}
					},
					{
						text: '喜欢，给好评',
						cssClass: 'zdy-text-color',
						onClick: function(dialog, e) {
							this.setStorage('isAlreadyScoreApp', '1', 1000 * 60 * 24 * 90);
							plus.runtime.openURL(
								"https://apps.apple.com/cn/app/%E5%92%94%E5%92%94%E7%BA%A6%E6%8B%8D-%E6%A8%A1%E7%89%B9%E6%91%84%E5%BD%B1%E7%BA%A6%E6%8B%8D%E5%B9%B3%E5%8F%B0/id1610751324"
							)
						},

					},
				],
			}).open();
		}

	},
	setStorage: function(key, value, ttl) {
		const now = new Date();
		const item = {
			value: value,
			expiry: now.getTime() + ttl,
		};
		if (app.device.iphone || app.device.ipad || app.device.macos) {
			try {
				plus.storage.setItem(key, JSON.stringify(item));
			} catch (e) {
				localStorage.setItem(key, JSON.stringify(item));
			}

		} else {
			localStorage.setItem(key, JSON.stringify(item));
		}
	},
	getStorage: function(key) {
		var itemStr = '';
		if (app.device.iphone || app.device.ipad || app.device.macos) {
			try {
				itemStr = plus.storage.getItem(key);
			} catch (e) {
				itemStr = localStorage.getItem(key);
			}

		} else {
			itemStr = localStorage.getItem(key);
		}
		if (itemStr == null || itemStr == undefined || itemStr == "") {
			return null;
		}

		if (itemStr == "00000000") {
			return null;
		}
		const item = JSON.parse(itemStr);
		const now = new Date();
		if (now.getTime() > item.expiry) {
			this.clearStorage(key);
			return null;
		}
		return item.value;
	},
	clearStorage: function(key) {
		if (app.device.iphone || app.device.ipad || app.device.macos) {
			if (window.plus) {
				plus.storage.setItem(key, "00000000");
			} else {
				localStorage.setItem(key, "00000000");
			}

		} else {
			localStorage.setItem(key, "00000000");
		}
	},
	acquireHH: function(self) {
		if (!common.checkLoginNoRouter()) {
			return;
		}
		app.request({
			url: global.getUserByHH,
			data: null,
			headers: authheaders,
			method: 'POST',
			dataType: 'json',
			success: function(r, status, xhr) {
				var data = DecryptToJson(r);
				if (data.code == 1) {
					userInfo = data.data;
					console.log("打印用户信息", userInfo);
					transformExtend.transformParam(userInfo);
					if (self != null) {
						self.$setState({
							userInfo: userInfo
						});
					}

				}
			}
		});
	},
	

}