var permissionUtil = {
	checkLocation: function() {
		console.log('校验地理位置开关')
		var permissionSelf = this;
		if (!window.plus) {
			return false;
		}
		if (plus.os.name == 'Android') {
			return permissionSelf.checkAndroidLocation();
		} else {
			return permissionSelf.checkIOSLocation();
		}
	},
	checkIOSLocation: function() {
		var permissionSelf = this;
		var cllocationManger = plus.ios.importClass("CLLocationManager");
		var enable = cllocationManger.locationServicesEnabled();
		var status = cllocationManger.authorizationStatus();
		// console.log("enable:" + enable);
		// console.log("status:" + status);
		plus.ios.deleteObject(cllocationManger);
		if (enable && status != 2) {
			console.log("手机系统的定位已经打开1");
			return true;
		}
		return false;
	},
	checkAndOpenSettingIOS: function(exeFunction) {
		var permissionSelf = this;
		console.log('检测是否开启定位');
		if (permissionSelf.checkIOSLocation()) {
			console.log("手机系统的定位已经打开2");
			return true;
		} else {
			console.log("手机系统的定位没有打开3");
			//  定位没有开启时  提示用户是否开启
			app.dialog.create({
				title: '温馨提示',
				text: '定位权限没有开启，是否去开启？',
				buttons: [{
						text: '取消',
					},
					{
						text: '去开启',
						onClick: function(dialog, e) {
							backToFrontEventArray.push(() => {
								app.dialog.close();
								permissionSelf.getCurrentLocation(exeFunction);
							})
							var UIApplication = plus.ios.importClass("UIApplication");
							var application2 = UIApplication.sharedApplication();
							var NSURL2 = plus.ios.importClass("NSURL");
							var setting2 = NSURL2.URLWithString("app-settings:"); // 打开应用权限
							application2.openURL(setting2);
							plus.ios.deleteObject(setting2);
							plus.ios.deleteObject(NSURL2);
							plus.ios.deleteObject(application2);
							// getatitude(exeFunction);

						}
					},
				],
				verticalButtons: false,
			}).open();
		}
		plus.ios.deleteObject(cllocationManger);
		return false;
	},
	updateLocation: function(p) {
		var updateParam = new Object();
		updateParam.latitude = p.coords.latitude;
		updateParam.longitude = p.coords.longitude;
		updateParam.city = p.address.city;
		updateParam.province = p.address.province;
		updateParam.district = p.address.district;
		app.request({
			url: global.updateLocationUrl,
			data: Encrypt(updateParam),
			headers: authheaders,
			method: 'POST',
			dataType: 'json',
			success: function(data, status, xhr) {}
		});
	},
	getCurrentLocation: function(exeFunction) {
		var permissionSelf = this;
		if (commonExtend.getStorage('isRejectAcquireLocation') && commonExtend.getStorage('isRejectAcquireLocation') == '1') {
			return;
		}
		try {
			console.log('开始获取位置');
			plus.geolocation.getCurrentPosition(function(p) {
				console.log('获取到了位置信息', JSON.stringify(p));
				common.setStorage("geoLocationAuth", 1);
				geoLocationAuth = true;
				// common.toast('位置信息'+ JSON.stringify(p.address));
				userInfo.longitude = p.coords.longitude;
				userInfo.latitude = p.coords.latitude;
				if (emptyUtil.isNotEmpty(p.address) && emptyUtil.isNotEmpty(p.address.city)) {
					console.log("城市信息不为空");
					positionProvince = p.address.province;
					positionCity = p.address.city;
					positionRefresh = 1;
					common.setStorage("positionProvince", positionProvince);
					common.setStorage("positionCity", positionCity);
					common.setStorage("positionRefresh", positionRefresh);
					console.log("设置完了位置缓存");
					if (exeFunction != null) {
						console.log("执行回调函数");
						try {
							exeFunction(p);
						} catch (e) {
							console.log("执行回调函数异常" + e.message);
						}
					}
					permissionSelf.updateLocation(p);
				} else {
					exeFunction(p);
				}
				if (userInfo.longitude == 5e-324) {
					if (plus.os.name == 'Android') {
						permissionSelf.checkAndOpenSettingAndroid(exeFunction);
					} else {
						permissionSelf.checkAndOpenSettingIOS(exeFunction);
					}
					return;
				}
				console.log('1首次获取定位' + userInfo.longitude + "," + userInfo.latitude);
			}, function(e) {
				console.log('获取位置信息异常' + JSON.stringify(e));
				// common.toast('获取位置信息异常' + JSON.stringify(e));
				if (plus.os.name == 'Android') {
					if (e.code == 'PERMISSION_DENIED' || e.code == 1 || e.code == -1501 || e.code == -
						1502) {
						// 不做处理，继续获取权限
					}
					permissionSelf.checkAndOpenSettingAndroid(exeFunction);
				} else {
					permissionSelf.checkAndOpenSettingIOS(exeFunction);
				}
			}, {
				provider: 'system',
				geocode: true
			});
		} catch (e) {
			toast('请开启定位功能');
		}

	},

	checkAndroidLocation: function() {
		var permissionSelf = this;
		var context = plus.android.importClass("android.content.Context");
		var locationManager = plus.android.importClass("android.location.LocationManager");
		var main = plus.android.runtimeMainActivity();
		var mainSvr = main.getSystemService(context.LOCATION_SERVICE);
		var ismain = mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER)
		if (ismain == false) {
			return ismain;
		} else {
			//获取检测权限的状态
			var checkResult = plus.navigator.checkPermission("LOCATION");
			switch (checkResult) {
				case 'authorized':
					return true;
				case 'denied':
					return false;
				case 'undetermined':
					return false;
				case 'unknown':
					return false;
				default:
					return false;
			}
		}
	},

	checkAndOpenSettingAndroid: function(exeFunction) {
		var permissionSelf = this;
		var context = plus.android.importClass("android.content.Context");
		var locationManager = plus.android.importClass("android.location.LocationManager");
		var main = plus.android.runtimeMainActivity();
		var mainSvr = main.getSystemService(context.LOCATION_SERVICE);
		var ismain = mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER)
		//ismain false : 系统权限没有开启 true :系统权限已经开启
		var btnArray = ['取消', '设置'];
		if (ismain == false) {
			if (commonExtend.getStorage('isRejectAcquireLocation') && commonExtend.getStorage('isRejectAcquireLocation') == '1') {
				return;
			}
				mui.confirm('定位权限没有开启，是否去开启？', '定位服务已关闭', btnArray,
					function(e) {
						var main = plus.android.runtimeMainActivity();
						var Intent = plus.android.importClass("android.content.Intent");
						var mIntent = new Intent('android.settings.LOCATION_SOURCE_SETTINGS');
						main.startActivity(mIntent);
					});

		} else {
			// successCallBack 1:已经给到权限了 2、用户点击允许  
			// errorCallBack 1:本来就是拒接的  2、用户点击拒接  
			permissionSelf.checkAndroidPermission("LOCATION", function(res) {
				// 下面逻辑  
				backToFrontEventArray.push(() => {
					// app.dialog.close();
					permissionSelf.getCurrentLocation(exeFunction);
				})
			}, function(res) {
				if (res == "1" || res == "2") {
					if (commonExtend.getStorage('isRejectAcquireLocation') && commonExtend.getStorage('isRejectAcquireLocation')=='1') {
						return;
					}
						mui.confirm('定位权限被禁止，请到设置权限里找到应用手动开启权限，否则将不能使用此功能。', '定位权限被禁止', btnArray,
							function(e) {
								if (e.index == 1) {
									var Intent = plus.android.importClass("android.content.Intent");
									var Settings = plus.android.importClass(
										"android.provider.Settings");
									var Uri = plus.android.importClass("android.net.Uri");
									var mainActivity = plus.android.runtimeMainActivity();
									var intent = new Intent();
									intent.setAction(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
									var uri = Uri.fromParts("package", mainActivity
									.getPackageName(),
										null);
									intent.setData(uri);
									mainActivity.startActivity(intent);
								} else {
									// 默认不处理
									commonExtend.setStorage('isRejectAcquireLocation','1',1000*60*60*24*3);
								}

							});
					
				} else {
					toast(res);
				}

			})
		}
	},

	checkAndroidPermission: function(permissionIdentity, successCallBack, errorCallBack) {
		//权限标识转换成大写
		var permissionIdentity = permissionIdentity.toUpperCase();
		//获取检测权限的状态
		var checkResult = plus.navigator.checkPermission(permissionIdentity);
		//权限状态是否正常
		var permissionStatusOk = false;
		//权限中文名称
		var permissionName = '';
		//对应 andorid 的具体权限
		var androidPermission = '';
		//获取权限中文意思与对应 android 系统的权限字符串
		switch (permissionIdentity) {
			case 'LOCATION':
				permissionName = '定位';
				androidPermission = 'android.permission.ACCESS_COARSE_LOCATION';
				break;
		}

		//判断检查权限的结果    
		switch (checkResult) {
			case 'authorized':
				//正常的    
				permissionStatusOk = true
				break;
			case 'denied':
				//表示程序已被用户拒绝使用此权限，如果是拒绝的就再次提示用户打开确认提示框    
				//如果有该权限但是没有打开不进行操作还是会去申请或手动打开    
				// console.log('已关闭' + permissionName + '权限')    
				// errorCallBack('已关闭' + permissionName + '权限');    
				// return    
				break;
			case 'undetermined':
				// 表示程序未确定是否可使用此权限，此时调用对应的API时系统会弹出提示框让用户确认    
				// this.requestPermissions(androidPermission, permissionName, successCallBack, errorCallBack)    
				// errorCallBack('未确定' + permissionName + '权限');    
				// return    
				break;
			case 'unknown':
				errorCallBack('无法查询' + permissionName + '权限');
				return
				break;
			default:
				errorCallBack('不支持' + permissionName + '权限');
				return
				break;
		}

		//如果权限是正常的执行成功回调    
		if (permissionStatusOk) {
			successCallBack("1")
		} else {
			//如果不正常，如果是 andorid 系统，就动态申请权限    
			if (plus.os.name == 'Android') {
				//动态申请权限    
				plus.android.requestPermissions([androidPermission], function(e) {
					if (e.deniedAlways.length > 0) {
						//权限被永久拒绝    
						// 弹出提示框解释为何需要定位权限，引导用户打开设置页面开启    
						//errorCallBack(permissionName + ' 权限被永久拒绝，请到设置权限里找到应用手动开启权限，否则将不能使用此功能。')  
						errorCallBack("1")

						// console.log('Always Denied!!! ' + e.deniedAlways.toString());    
					}
					if (e.deniedPresent.length > 0) {
						//权限被临时拒绝    
						// 弹出提示框解释为何需要定位权限，可再次调用plus.android.requestPermissions申请权限    
						//errorCallBack('拒绝开启 ' + permissionName + ' 权限，将不能使用此功能！')  
						errorCallBack('2')
						// console.log('Present Denied!!! ' + e.deniedPresent.toString());    
					};
					if (e.granted.length > 0) {
						//权限被允许    
						//调用依赖获取定位权限的代码    
						successCallBack("2")
						// console.log('Granted!!! ' + e.granted.toString());    
					}
				}, function(e) {
					errorCallBack('请求 ' + permissionName + ' 权限失败，' + +JSON.stringify(e))
					// console.log('Request Permissions error:' + JSON.stringify(e));    
				})
			}
		}
	}

}